<template>
  <v-card min-height="300" tile class="d-flex flex-column border-light-accent">
    <v-progress-linear
      :value="(100 / (countStep - 1)) * (step - 1)"
      color="accent lighten-1"
      height="6"
      top
    />

    <v-stepper v-model="step" class="elevation-0 grow d-flex flex-column justify-center">
      <v-stepper-items>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" step="1">
          <h2 class="font-weight-light mb-2 mt-3 text-center">
            Which city are you looking for?
          </h2>
          <v-btn-toggle v-model="city" mandatory class="d-flex flex-wrap no-gutters">
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent lighten-1" tile height="80">
                Dallas
              </v-btn>
            </v-col>
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent" tile height="80">
                Houston
              </v-btn>
            </v-col>
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent darken-1" tile height="80">
                Austin
              </v-btn>
            </v-col>
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent darken-2" tile height="80">
                San Antonio
              </v-btn>
            </v-col>
          </v-btn-toggle>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" step="2">
          <h2 class="font-weight-light mb-2 mt-3 text-center">
            What size home are you looking for?
          </h2>
          <v-btn-toggle v-model="size" mandatory class="d-flex flex-wrap no-gutters">
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent lighten-1" tile height="80">
                Studio
              </v-btn>
            </v-col>
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent" tile height="80">
                1 Bed
              </v-btn>
            </v-col>
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent darken-1" tile height="80">
                2 Bed
              </v-btn>
            </v-col>
            <v-col cols="6" @click="next">
              <v-btn depressed block color="accent darken-2" tile height="80">
                3 Bed +
              </v-btn>
            </v-col>
          </v-btn-toggle>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" step="3">
          <h2 class="font-weight-light mb-2 mt-3 text-center">
            When are you planning to move?
          </h2>
          <v-btn-toggle v-model="planning" mandatory class="d-flex flex-wrap no-gutters">
            <v-col cols="auto" class="grow" @click="next">
              <v-btn depressed block color="accent lighten-1" tile height="80">
                With In 1 Months
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" @click="next">
              <v-btn depressed block color="accent" tile height="80">
                Between 1 to 2 months
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" @click="next">
              <v-btn depressed block color="accent darken-1" tile height="80">
                More than 2+ Months
              </v-btn>
            </v-col>
          </v-btn-toggle>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" step="4">
          <h2 class="font-weight-light mb-2 mt-3 text-center">
            Approximate Credit Score
          </h2>
          <v-btn-toggle v-model="credit" mandatory class="d-flex flex-wrap no-gutters">
            <v-col cols="auto" class="grow" @click="next">
              <v-btn depressed block color="accent lighten-1" tile height="80">
                Below 550
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" @click="next">
              <v-btn depressed block color="accent" tile height="80">
                550-600
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" @click="next">
              <v-btn depressed block color="accent darken-1" tile height="80">
                600-650
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" @click="next">
              <v-btn depressed block color="accent darken-2" tile height="80">
                650+
              </v-btn>
            </v-col>
          </v-btn-toggle>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" step="5">
          <h2 class="font-weight-light mb-2 mt-3 text-center">
            Any pets?
          </h2>
          <v-btn-toggle v-model="pets" mandatory multiple class="d-flex flex-wrap no-gutters">
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="pets = pets.filter(v => v !== 2)">
              <v-btn depressed block color="accent lighten-1" tile height="80">
                Cat
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="pets.includes(0)" />
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="pets = pets.filter(v => v !== 2)">
              <v-btn depressed block color="accent" tile height="80">
                Dog
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="pets.includes(1)" />
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="pets = [2]">
              <v-btn depressed block color="accent darken-1" tile height="80">
                No pets
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="pets.includes(2)" />
              </v-btn>
            </v-col>
          </v-btn-toggle>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" step="6">
          <h2 class="font-weight-light mb-2 mt-3 text-center">
            Select below that applicable to you
          </h2>
          <v-btn-toggle v-model="options" mandatory multiple class="d-flex flex-wrap no-gutters">
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="options = [0]">
              <v-btn depressed block color="accent lighten-1" tile height="80">
                None
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="options.includes(0)" />
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="options = options.filter(v => v !== 0)">
              <v-btn depressed block color="accent" tile height="80">
                Section-8
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="options.includes(1)" />
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="options = options.filter(v => v !== 0)">
              <v-btn depressed block color="accent darken-1" tile height="80">
                Evictions
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="options.includes(2)" />
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="options = options.filter(v => v !== 0)">
              <v-btn depressed block color="accent darken-2" tile height="80">
                Broken Lease
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="options.includes(3)" />
              </v-btn>
            </v-col>
            <v-col cols="auto" class="grow" style="min-width: 100px" @click="options = options.filter(v => v !== 0)">
              <v-btn depressed block color="accent darken-3" tile height="80">
                Felonies
                <v-checkbox disabled style="position: absolute; right: 0; top: 0" :value="options.includes(4)" />
              </v-btn>
            </v-col>
          </v-btn-toggle>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" step="7">
          <h2 class="font-weight-light mb-5 mt-3 text-center">
            What's your monthly budget?
          </h2>
          <v-row no-gutters class="my-5">
            <v-col cols="12" class="text-center font-weight-bold title mb-3">
              ${{ price }}
            </v-col>
            <v-col cols="12">
              <v-slider
                v-model="price"
                class="mx-5"
                color="accent"
                track-color="accent lighten-2"
                min="500"
                max="5000"
                step="100"
              />
            </v-col>
          </v-row>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content v-if="!isLoggedIn" class="py-3 pb-0" step="8">
          <h2 class="font-weight-light mb-5 mt-3 text-center">
            Find your dream apartment with zero stress and VIP service, and it's free!
          </h2>
          <v-form ref="form" v-model="isValid" lazy-validation class="d-flex flex-wrap no-gutters">
            <v-col cols="12">
              <v-text-field
                v-model="fields.name"
                required
                dense
                outlined
                :rules="[v => !!v || 'Name is required']"
                type="text"
                label="Your Name*"
              />
            </v-col>
            <v-col cols="12">
              <v-text-field
                v-model="fields.email"
                required
                dense
                outlined
                :rules="emailRules"
                type="email"
                label="Email Address*"
              />
            </v-col>
            <v-col cols="12">
              <v-text-field
                v-model="fields.phone"
                required
                dense
                outlined
                type="tel"
                :rules="phoneRules"
                label="Contact Number*"
              />
            </v-col>
          </v-form>
        </v-stepper-content>
        <!-- Step -->
        <v-stepper-content class="py-3 pb-0" :step="countStep">
          <h2 class="font-weight-light text-center">
            Thank you {{ fields.name }}
          </h2>
          <span class="text-center d-block">
            We'll be reaching out to you very shortly!
          </span>
        </v-stepper-content>
      </v-stepper-items>
    </v-stepper>
    <v-card-actions class="shrink pt-0 mt-2" style="min-height: 44px">
      <v-btn v-show="step !== minStep && step !== countStep" text @click="back">
        Back
      </v-btn>
      <v-spacer />
      <v-btn
        v-if="step < lastStep || (step > 3 && step !== countStep)"
        text
        :disabled="!isLoggedIn && step === (countStep - 1) && !isValid"
        @click="next"
        v-text="'Next'"
      />
      <v-btn
        v-else-if="step === countStep && showClose"
        text
        @click="next"
        v-text="'Close'"
      />
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'
import { defineComponent, ref, reactive, computed } from '@vue/composition-api'
import { IRentProperty } from 'apartments-shared'

export default defineComponent({
  name: 'AppConnectExpert',
  props: {
    property: {
      required: false,
      type: Object as () => IRentProperty,
      default: null
    },
    showClose: {
      required: false,
      type: Boolean,
      default: true
    }
  },
  setup (props, { emit, root }) {
    const form = ref<any>(null)
    const minStep = ref(props.property ? 2 : 1)
    const step = ref(minStep.value)
    const lastStep = ref(1)
    const isValid = ref(true)

    type Options = 0 | 1 | 2
    const price = ref(500)
    const city = ref<Options | 3>(0)
    const size = ref<Options | 3>(0)
    const planning = ref<Options>(0)
    const credit = ref(0)
    const pets = ref<[Options, Options] | [Options]>([2])
    const options = ref<[Options, Options] | [Options]>([0])
    const isLoggedIn = computed(() => root.$store.getters['auth/isLoggedIn'])
    const countStep = computed(() => isLoggedIn.value ? 8 : 9)
    const fields = reactive({
      name: '',
      email: '',
      phone: '',
      property: props.property?.id ?? null
    })

    const next = async () => {
      if (step.value === countStep.value - 1 && !isLoggedIn.value) {
        form.value.validate()
        await Vue.nextTick()
        if (isValid.value) {
          step.value++
        }
      } else if (step.value === countStep.value) {
        emit('finish')
      } else {
        step.value++
        if (step.value > lastStep.value) { lastStep.value = step.value }
      }
    }
    const back = () => {
      step.value--
    }
    return {
      step,
      back,
      price,
      city,
      lastStep,
      isValid,
      minStep,
      credit,
      size,
      planning,
      form,
      isLoggedIn,
      options,
      countStep,
      fields,
      pets,
      emailRules: [
        (v: string) => !!v || 'E-mail is required',
        (v: string) => /.+@.+\..+/.test(v) || 'E-mail must be valid'
      ],
      phoneRules: [
        (v: string) => !!v || 'Phone number is required'
      ],
      next
    }
  }
})
</script>

<style>
.border-light-accent {
  border: 2px solid #FFDED2 !important;
}
</style>
